head	4.1;
access;
symbols;
locks;
comment	@ * @;


4.1
date	2011.05.23.13.52.53;	author Average;	state Exp;
branches;
next	1.1;

1.1
date	2011.05.23.13.50.51;	author Average;	state Exp;
branches;
next	;


desc
@@


4.1
log
@n
@
text
@UNIT Render;

INTERFACE
{$H+}
USES
Classes,SysUtils,Math,VPUtils,MkBMP,OS2BASE,OS2DEF,OS2PMAPI;

CONST
    ConstLengthLimit=1e15;
    ConstLengthFar=1e30;
    ConstPlaneLimit=1e-10;
    ConstEpsilon=1e-3;
    MaxDepth=10;
    VacuumRefractiveIndex=1.0;

TYPE
    ColorType=RECORD
        r,g,b:BYTE;
    END;
    VectorRecord=Record
        x,y,z:SINGLE;
    end;
    SpectrumRecord=record
        r,g,b:SINGLE;
    end;

    RayRecord=Record
        Org,Dir:VectorRecord;
    END;

    MaterialRecord=Record
        col:SpectrumRecord;
        reflection:single;
        refraction:single;
        RefractiveRate :single;  // ܗ
        EmissionColor:SpectrumRecord;
    END;

    // J
    CameraRecord=Record
        eye, origin, xaxis, yaxis:VectorRecord;
    end;



    LightClass=CLASS
        pos:VectorRecord;
        power:SpectrumRecord;
        constructor Create(pos_:VectorRecord;power_:SpectrumRecord);
    END;

    IntersectionRecord=Record
        t:single;
        p,n:VectorRecord;
        Material:MaterialRecord;
    end;

    IntersectableClass=CLASS
        constructor Create;virtual;abstract;
        function Intersect(var isect:IntersectionRecord;
                           Ray:RayRecord):boolean;virtual;abstract;
    END;

    SphereClass=CLASS(IntersectableClass)
        center:VectorRecord;
        radius:single;
        Material:MaterialRecord;

        constructor Create(center_:VectorRecord;
                           radius_:single;
                           Material_:MaterialRecord);virtual;
        function Intersect(var isect:IntersectionRecord;
                           Ray:RayRecord):boolean;override;

    end;
    PlaneClass=CLASS(IntersectableClass)
        n:VectorRecord;
        d:single;
        Material:MaterialRecord;
        constructor Create(p_,n_:VectorRecord;
                           Material_:MaterialRecord);virtual;
        function Intersect(var isect:IntersectionRecord;
                           ray:RayRecord):boolean;override;
    end;

    CheckedPlaneClass=CLASS(PlaneClass)
        InvGridSize:single;
        Material2:MaterialRecord;
        constructor Create(p_,n_:VectorRecord;
                           GridSize:single;
                           Material_,Material2_:MaterialRecord);virtual;
        function Intersect(var isect:IntersectionRecord;
                           ray:RayRecord):boolean;override;
    end;

    SceneClass=Class
        Black,SkyColor:SpectrumRecord;
        LightList,ObjList:TList;
        constructor Create;
        procedure AddObj(OB:IntersectableClass);
        procedure AddLight(Light:LightClass);
        function random_dir_over_hemisphere(n:VectorRecord):VectorRecord;
        function Trace(ray:RayRecord;Depth:integer):SpectrumRecord;
        function FindNearestIntersectionRecord(ray:RayRecord):IntersectionRecord;
        function lighting(p,n:VectorRecord;m:MaterialRecord):SpectrumRecord;
        function Visible(Org,Target:VectorRecord):boolean;
        FUNCTION DiffuseLighting(p,n,lightPos:VectorRecord;
                                 DiffuseColor,
                                 LightPower:SpectrumRecord):SpectrumRecord;
    end;


function CreateVector(x_,y_,z_:SINGLE):VectorRecord;
FUNCTION VecAdd(V1,V2 :VectorRecord):VectorRecord;
FUNCTION VecSub(Vo,Vs :VectorRecord):VectorRecord;
FUNCTION VecScale(V:VectorRecord;S :SINGLE):VectorRecord;
FUNCTION VecNeg(v:VectorRecord):VectorRecord;
FUNCTION Veclen(v:VectorRecord):SINGLE;
FUNCTION VecNormalize(V:VectorRecord):VectorRecord;
FUNCTION VecDot(V1,V2 :VectorRecord):SINGLE;//
FUNCTION VecCross(V1,V2 :VectorRecord):VectorRecord;//O


function CreateSpectrum(r_,g_,b_:SINGLE):SpectrumRecord;
FUNCTION SpecAdd(v1,v2:SpectrumRecord):SpectrumRecord;
FUNCTION SpecMul(v1,v2:SpectrumRecord):SpectrumRecord;
FUNCTION SpecScale(v:SpectrumRecord;s:SINGLE):SpectrumRecord;
FUNCTION SpecToColor(v:SpectrumRecord):ColorType;

function  CreateMaterial(col_:SpectrumRecord):MaterialRecord;

function CreateIntersect:IntersectionRecord;
function HitIntersect(isect:IntersectionRecord):boolean;

function CreateRay(o,d:VectorRecord):RayRecord;

function CameraLookat(eye_,target,up:VectorRecord;
                      fov:single;
                      width,height:integer):CameraRecord;
function GetCameraRay(CM:CameraRecord;x,y:single):RayRecord;


type
    GraphDataClass=CLASS(MingViewClass)
        Cx,Cy:integer;
        JpegQuality:INTEGER;
        isFitPicture:boolean;
        constructor Create;OverRide;
        PROCEDURE SetupHeader(px,py:INTEGER);
        FUNCTION GetDrawRect:RectL;
        PROCEDURE DrawBitmap(rect:RectL;ps:hps);
        PROCEDURE SaveFile(SaveSt:string);
        procedure SetPixel(x,y:integer;Col:ColorType);

    END;


IMPLEMENTATION



function CreateVector(x_,y_,z_:SINGLE):VectorRecord;
BEGIN
    result.x:=x_;result.y:=y_;result.z:=z_;
END;
FUNCTION VecAdd(V1,V2 :VectorRecord):VectorRecord;
BEGIN
    result.x:=V1.x+V2.x;
    result.y:=V1.y+V2.y;
    result.z:=V1.z+V2.z;
END;
FUNCTION VecSub(Vo,Vs :VectorRecord):VectorRecord;
BEGIN
    result.x:=Vo.x-Vs.x;
    result.y:=Vo.y-Vs.y;
    result.z:=Vo.z-Vs.z;
END;
FUNCTION VecScale(V:VectorRecord;S :SINGLE):VectorRecord;
BEGIN
    result.x:=V.x*s;
    result.y:=V.y*s;
    result.z:=V.z*s;
END;
FUNCTION VecNeg(V:VectorRecord):VectorRecord;
BEGIN
    result.x:=-V.x;
    result.y:=-V.y;
    result.z:=-V.z;
END;
FUNCTION Veclen(V:VectorRecord):SINGLE;
BEGIN
   result:=sqrt(V.x*V.x+V.y*V.y+V.z*V.z);
END;

FUNCTION VecNormalize(V:VectorRecord):VectorRecord;
BEGIN
    result:=Vecscale(V,1.0/VecLen(V) );
END;
FUNCTION VecDot(V1,V2 :VectorRecord):SINGLE;//
BEGIN
    result:=v1.x*v2.x+v1.y*v2.y+v1.z*v2.z;
END;
FUNCTION VecCross(V1,V2 :VectorRecord):VectorRecord;//O
BEGIN
    result.x:=V1.y * v2.z - v2.y * V1.z;
    result.y:=V1.z * v2.x - v2.z * V1.x;
    result.z:=V1.x * v2.y - v2.x * V1.y;
END;


function CreateSpectrum(r_, g_, b_:SINGLE):SpectrumRecord;
BEGIN
    result.r := r_;
    result.g := g_;
    result.b := b_;
END;

FUNCTION SpecAdd(v1,v2:SpectrumRecord):SpectrumRecord;
BEGIN
    result.r:=v1.r + v2.r;
    result.g:=v1.g + v2.g;
    result.b:=v1.b + v2.b;
END;

FUNCTION SpecMul(v1,v2:SpectrumRecord):SpectrumRecord;
BEGIN
    result.r:=v1.r * v2.r;
    result.g:=v1.g * v2.g;
    result.b:=v1.b * v2.b;
END;
FUNCTION SpecScale(v:SpectrumRecord;s:SINGLE):SpectrumRecord;
BEGIN
    result.r:=v.r * s;
    result.g:=v.g * s;
    result.b:=v.b * s;
END;
FUNCTION SpecToColor(v:SpectrumRecord):ColorType;
VAR
    i:ColorType;
    FUNCTION RealToByte(r:SINGLE):BYTE;
    BEGIN
        IF r>255 THEN r:=255;
        result:=Trunc(r);
    END;
BEGIN
    i.r := RealToByte(v.r * 255);
    i.g := RealToByte(v.g * 255);
    i.b := RealToByte(v.b * 255);
    result:=i;
END;


function CreateRay(o,d:VectorRecord):RayRecord;
begin
    result.org:=o;
    result.dir:=d;
end;

function CreateMaterial(col_:SpectrumRecord):MaterialRecord;
begin
    result.col:=col_;
    result.reflection:=0; //˗
    result.refraction:=0; //܂̊
    result.RefractiveRate := 1;  // ܗ
    result.EmissionColor.r:=0;
    result.EmissionColor.g:=0;
    result.EmissionColor.b:=0;

end;

constructor LightClass.Create(pos_:VectorRecord;power_:SpectrumRecord);
begin
    pos:=pos_;
    power:=power_;
end;

function CreateIntersect:IntersectionRecord;
begin
    result.t:=ConstLengthFar;
end;

function HitIntersect(isect:IntersectionRecord):boolean;
begin
    result:=((isect.t<0) or (isect.t<ConstLengthLimit));
end;

constructor SphereClass.Create(center_:VectorRecord;
                               radius_:single;
                               Material_:MaterialRecord);
begin
    center:=center_;
    radius:=radius_;
    material:=material_;
end;

function SphereClass.Intersect(var isect:IntersectionRecord;
                                Ray:RayRecord):boolean;
var
    o_c:VectorRecord;
    b,c,d,dR,t:single;
begin

    result:=FALSE;
    o_c:=VecSub(ray.org,center);
    b:=VecDot(ray.dir,o_c);
    c:=VecDot(o_c,o_c)-sqr(radius);
    d:=b*b-c;
    IF d>=0 then begin
        dR:=sqrt(d);
        t:=-b-dR;
        IF t<=ConstEpsilon then t:=-B+dR;
        IF ((t>ConstEpsilon) and (isect.t>t)) then begin
            isect.t:=t;
            isect.p:=VecAdd(ray.org,VecScale(ray.dir,t));
            isect.n:=VecNormalize(VecSub(isect.p,center) );
            isect.material:=material;
            result:=TRUE;
            exit;
        end;
    end;
end;

constructor PlaneClass.Create(p_,n_:VectorRecord;
                              Material_:MaterialRecord);
begin
    n := VecNormalize(n_);
    d := -VecDot(p_,n);
    Material:=Material_;
end;

function PlaneClass.Intersect(var isect:IntersectionRecord;ray:RayRecord):boolean;
var
    v,t:single;
begin
    result:=FALSE;
    v:=VecDot(n,ray.dir);
    IF abs(v)<ConstPlaneLimit then begin
        result:=false;
        exit;
    end;
    t:=-(VecDot(n,ray.org)+d)/v;
    if ((t>ConstEpsilon)and(isect.t>t)) then begin
        isect.t:=t;
        isect.p:=VecAdd(ray.org,VecScale(ray.dir,t));
        isect.n:=n;
        isect.material:=material;
        result:=TRUE;
        exit;
    end;
end;

constructor CheckedPlaneClass.Create(p_,n_:VectorRecord;
                                     GridSize:single;
                                     Material_,Material2_:MaterialRecord);
begin
    inherited Create(p_,n_,Material_);
    InvGridSize:=1/GridSize;
    Material2:=Material2_;
end;

function CheckedPlaneClass.Intersect(var isect:IntersectionRecord;
                                     ray:RayRecord):boolean;
var
    i:integer;
begin
    result:=false;
    if inherited Intersect(isect,ray) then begin
        result:=true;
        i:=floor(isect.p.x*InvGridSize)
          +floor(isect.p.y*InvGridSize)
          +floor(isect.p.z*InvGridSize);
        IF odd(i) then isect.material:=Material2;
    end;

end;


// J

  // _炠ʒu悤ɐݒs
function  CameraLookat(eye_,target,up:VectorRecord;
                       fov:single;
                       width,height:integer):CameraRecord;
var
    CM:CameraRecord;
    imageplane:single;
    t_o,center:VectorRecord;
begin
    CM.eye := eye_;
    imageplane := (height / 2) / tan(fov / 2);
    t_o := VecNormalize(VecSub(target,CM.eye));
    CM.xaxis := VecNormalize(VecCross(t_o,up));
    CM.yaxis := VecCross(t_o,CM.xaxis);
    center := VecScale(t_o,imageplane);
    CM.origin := VecSub(
                    VecSub(center,VecScale(CM.xaxis,(0.5 * width)) ),
                    VecScale(CM.yaxis,(0.5 * height))
                 );
    result:=CM;
end;

function GetCameraRay(CM:CameraRecord;x,y:single):RayRecord;
var
    dir:VectorRecord;
begin
    dir:= VecNormalize(
                VecAdd(VecAdd(CM.origin,VecScale(CM.xaxis,x)),
                       (VecScale(CM.yaxis,y)))
          );
    result:=CreateRay(CM.eye, dir);
end;


constructor SceneClass.Create;
begin
    ObjList:=TList.Create;
    LightList:=TList.Create;
    Black:=CreateSpectrum(0,0,0);
    SkyColor:=CreateSpectrum(0.7,0.75,0.8);
end;

procedure SceneClass.AddObj(OB:IntersectableClass);
begin
    ObjList.Add(OB);
end;

procedure SceneClass.AddLight(Light:LightClass);
begin
    LightList.Add(Light);
end;


// ̃_ȕ肷
function SceneClass.random_dir_over_hemisphere(n:VectorRecord):VectorRecord;
var
    x,y,z:single;
    ll:single;
begin
    while true do begin
        x:=(random(2000)-1000);x:=x/1000;
        y:=(random(2000)-1000);y:=y/1000;
        z:=(random(2000)-1000);z:=z/1000;
        ll:=x*x+y*y+z*z;
        if ((ll>0)and(ll<1.0)) THEN BEGIN
            ll:=Sqrt(ll);
            result.x:=x/ll;
            result.y:=y/ll;
            result.z:=z/ll;

            IF VecDot(result,n)<0 then result:=VecNeg(result);
            exit;
        END;
    end;
end;


function SceneClass.Trace(ray:RayRecord;Depth:integer):SpectrumRecord;
    // gU˖ʂ̔ˌvZ
    function TraceDiffuseReflection(p,n:VectorRecord;
                                    diffuse_color:SpectrumRecord;
                                    depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
        Li,fr:SpectrumRecord;
        m:materialRecord;
        dot:single;
    begin
    // _̖@@ɑ΂āÃ_ȕɃC΂
        r:=random_dir_over_hemisphere(n);
        Li := trace( CreateRay(p, r), depth);
        fr := SpecScale(diffuse_color,1.0 / PI);
        dot := VecDot(n,r);
        result:=SpecScale( SpecMul(Li,fr),2 * PI * dot);
    end;
    function reflect(v, n:VectorRecord):VectorRecord;
    begin
        result:= VecSub(v,(VecScale(n,(2 * VecDot(v,n)))));
    end;
    function TraceReflection(p,n,v:VectorRecord;depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
    begin
        r := reflect(v, n);
        result:=trace(CreateRay(p, r), depth);
    end;
    function refract(var isOK:boolean;v,n:VectorRecord;eta_i,eta_t:single):VectorRecord;
    var
       VdotN,eta,d:single;
       a,b:VectorRecord;
    begin
        isOK:=true;
        VdotN := VecDot(v,n);
        eta := eta_i / eta_t;
        d := 1.0 - sqr(eta) * (1.0 - sqr(VdotN));
        IF d>0 then begin
            a := VecSub(v,( VecScale(VecScale(n,VdotN),eta) ));
            b := VecScale(n,sqrt(d));
            result:=VecSub(a,b);
            exit;
        end;
        isOK:=FALSE;
    end;

    function TraceRefraction(p,n,v:VectorRecord;
                             eta_i,eta_t:single;
                             depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
        isOk:boolean;
    begin
        r:=refract(isOK,v,n,eta_i,eta_t);
        IF isOK then
           // 
           result:=trace(CreateRay(p,r),depth)
        else
           // S
           result:=TraceReflection(p, n, v, depth);
    end;
    function interact_surface(raydir,p,n:VectorRecord;
                              m:MaterialRecord;
                              eta_i, eta_t:single;
                              depth:integer):SpectrumRecord;
    var
       ks,kt,kd:single;
       t:single;
       c:SpectrumRecord;
    begin
        ks := m.reflection;
        kt := m.refraction;
        kd := 1.0 - ks - kt;
    // [1] ʔˁE܁EgU˂̉exɉĂ̂̈I
        t := random(1000)/1000;
        IF t<ks then begin
            c:=TraceReflection(p,n,raydir,depth)  ;
            result:=SpecMul(c,m.col);
            exit;
        end;
        IF t<(ks+kt) then begin
            c := TraceRefraction(p, n, raydir, eta_i, eta_t, depth);
            result:=SpecMul(c,m.col);
            exit;
        end;
        result:=TraceDiffuseReflection(p, n, m.col, depth);
    end;
var
    isect:IntersectionRecord;
    m:MaterialRecord;
    L,c,Col:SpectrumRecord;
    ks,kd,kt:single;
    dot:single;
begin
    Depth:=Depth+1;
    IF Depth>MaxDepth then begin
        result:=Black;
        exit;
    end;
    isect := FindNearestIntersectionRecord(ray);
    IF HitIntersect(isect)=FALSE then begin
        result:=SkyColor;
        exit;
    end;
    m:= isect.material;
    dot := VecDot(isect.n,ray.dir);
    if (dot < 0) THEN BEGIN  // ̂ɊO瓖
        col := interact_surface(ray.dir, isect.p, isect.n, m, VacuumRefractiveIndex, m.RefractiveRate, depth);
        result:=SpecAdd(col, SpecScale(m.EmissionColor,-dot));
        exit;
    end
    ELSE
        // ̂očs
        result:=interact_surface(ray.dir, isect.p, VecNeg(isect.n), m, m.RefractiveRate, VacuumRefractiveIndex, depth);

{*****
    m := isect.material;
    IF (isect.n.dot(ray.dir)<0) THEN BEGIN
        L:=Black;
        ks:= m.reflection;
        if (ks > 0) THEN BEGIN
           c := TraceReflection(isect.p, isect.n, ray.dir, depth);
           L := L.add(c.scale(ks).mul(m.col));
        END;
        kt := m.refraction;
        IF (kt>0) THEN BEGIN
            c:=TraceRefraction(isect.p,isect.n,Ray.dir,
                               VacuumRefractiveIndex,
                               m.RefractiveRate,
                               Depth);
            L:=L.add(c.scale(kt).mul(m.col));
        END;
        kd := 1- ks -kt ;
        if (kd > 0) THEN BEGIN
           c := lighting(isect.p, isect.n, isect.material);
           L := L.add(c.scale(kd));
        END;
        result:=L;
    END
    ELSE
        result:=TraceRefraction(isect.p, isect.n.neg, ray.dir,
                                m.RefractiveRate,
                                VacuumRefractiveIndex, depth);
****}
end;

function SceneClass.FindNearestIntersectionRecord(ray:RayRecord):IntersectionRecord;
var
    isect:IntersectionRecord;
    i:integer;
    OBJ:IntersectableClass;
begin
    isect := CreateIntersect;
    i:=0;
    while i<ObjList.count do begin
      OBJ:=IntersectableClass(ObjList[i]);
      obj.intersect(isect, ray);
      i:=i+1;
    end;
    result:=isect;
end;
function SceneClass.lighting(p,n:VectorRecord;m:MaterialRecord):SpectrumRecord;
var
    L,c:SpectrumRecord;
    Light:LightClass;
    i:integer;
begin
    L:=Black;//SpectrumRecord.Create(0,0,0);
    i:=0;
    while i<LightList.count do begin
        Light:=LightClass(LightList[i]);
        c:=DiffuseLighting(p,n,Light.pos,m.col,Light.power);
        L:=SpecAdd(L,c);
        i:=i+1;
    end;
    result:=L;
end;
function SceneClass.Visible(Org,Target:VectorRecord):boolean;
var
    t_o:VectorRecord;
    ShadowRay:RayRecord;
    isect:IntersectionRecord;
    n:integer;
    obj:IntersectableClass;
begin
    t_o := VecSub(target,org);
    // [2] VhEC߂
    ShadowRay:=CreateRay(org, VecNormalize(t_o));
    isect := CreateIntersect;
    // [3] ܂ł̋̏ɂ
    isect.t := VecLen(t_o);
    n:=0;
    while n<ObjList.count do begin
      obj := IntersectableClass(objlist[n]);
      if (obj.intersect(isect, ShadowRay))  THEN BEGIN
          result:=FALSE;
          exit;
      END;
      n:=n+1;
    end;
    result:=TRUE;
end;

FUNCTION SceneClass.DiffuseLighting(p,n,lightPos:VectorRecord;
                         DiffuseColor,LightPower:SpectrumRecord):SpectrumRecord;
VAR
    l_p,l:VectorRecord;
    dot,r,factor:SINGLE;
BEGIN
    result:=Black;
    l_p:=VecSub(LightPos,p);
    l:=VecNormalize(l_p);
    dot:=VecDot(n,l);
    IF dot>0 THEN BEGIN
        IF Visible(p,LightPos) THEN BEGIN
            r:=VecLen(l_p);
            factor:=dot / (4*PI*r*r);
            result:=SpecMul(SpecScale(LightPower,factor),DiffuseColor);
            exit;
        END;
    END;
END;




constructor GraphDataClass.Create;
BEGIN
    JpegQuality:=75;
    isFitPicture:=TRUE;
    inherited Create;
END;

PROCEDURE  GraphDataClass.SetupHeader(px,py:INTEGER);
begin
    inherited SetupHeader(px,py);
    Cx:=px;Cy:=py;
end;

FUNCTION GraphDataClass.GetDrawRect:RectL;
VAR
    cx,cy :LONGINT;(**bitmap size**)
    rect  :RectL;
BEGIN
    cx:=pBMPBody^.bmpCx;
    cy:=pBMPBody^.bmpCy;
    rect.xLeft:=0;Rect.xRight:=cx;
    rect.yTop:=cy;rect.yBottom:=0;
//    rect.xRight:=(Rect.xRight div 8)*8;
    GetDrawRect:=Rect;
END;


PROCEDURE GraphDataClass.DrawBitmap(rect:RectL;ps:hps);
VAR
    RectSrc,RectDest:RectL;
    hbm:HBITMAP;
    rc:bool;
    SrcXYRatio,DestXYRatio:double;
    yValue,xValue,xDiv,yDiv:integer;
BEGIN
    hbm:=GpiCreateBitmap(ps,
                        pBMPBody^.InfoHeader2,
                        CBM_INIT,
                        pBMPBody^.RG,
                        pBMPBody^.Info2);
    RectSrc.yTop:=pBMPBody^.bmpcy;
    RectSrc.yBottom:=0;
    RectSrc.xLeft:=0;
    RectSrc.xRight:=pBMPBody^.bmpCx;

    IF isFitPicture THEN BEGIN

        SrcXYRatio:=RectSrc.xRight / RectSrc.yTop;
        DestXYRatio:=rect.xRight/rect.yTop;

        RectDest:=rect;

        IF SrcXYRatio>DestXYRatio then begin
            xValue:=Rect.xRight; xDiv:=0;
            yValue:=Round(Rect.xRight / SrcXYRatio);
            yDiv:=(rect.yTop-yValue) div 2;
            RectDest.yBottom:=yDiv;
            RectDest.yTop:=RectDest.yTop-yDiv;
        end
        else begin
            yValue:=Rect.yTop; yDiv:=0;
            xValue:=Round(Rect.yTop * SrcXYRatio);
            xDiv:=(Rect.xRight-xValue) div 2;
            RectDest.xLeft:=xDiv;
            RectDest.xRight:=RectDest.xRight-xDiv;
        end;

        rc:=WinDrawBitmap(PS,Hbm,@@RectSrc,@@RectDest,1, 0,DBM_STRETCH);
    END
    ELSE BEGIN
        RectDest.xLeft:=( (Rect.xRight-Rect.xLeft)-
                          (RectSrc.xRight-RectSrc.xLeft) ) div 2
                          +Rect.xLeft;
        RectDest.yBottom:=( (Rect.yTop-Rect.yBottom)-
                            (RectSrc.yTop-RectSrc.yBottom) ) div 2
                          +Rect.yBottom;
        RectDest.yTop:= RectDest.yBottom+(RectSrc.yTop-RectSrc.yBottom);
        RectDest.xRight:= RectDest.xLeft+(RectSrc.xRight-RectSrc.xLeft);

        rc:=WinDrawBitmap(PS,Hbm,@@RectSrc,@@RectDest,1, 0,DBM_NORMAL);
    END;
    IF rc=FALSE THEN BEGIN
        HALT;
    END;
    GpiDeleteBitmap(HBM);
END;




PROCEDURE GraphDataClass.SaveFile(SaveSt:string);
BEGIN
    JpegFileSave(SaveSt,JpegQuality);
    //PingFileSave(SaveSt);
END;



procedure GraphDataClass.SetPixel(x,y:integer;Col:ColorType);
var
    Suffix:LongInt;
begin
    suffix:=(x+(Cy-y)*Cx)*3;
    pBMPBody^.rg[suffix  ]:=Col.b;
    pBMPBody^.rg[suffix+1]:=Col.g;
    pBMPBody^.rg[suffix+2]:=Col.r;

end;



BEGIN
    Randomize;
END.

Traceŗp





$Log: RENDER.PAS $
Revision 1.1  2011/05/23 13:50:51  Average
Initial revision

Revision 3.1  2011/05/21 13:27:29  Average
Ƃ肠AOς(MLTUnitrpcalc)

Revision 2.7  2011/05/19 15:10:25  Average
Ƃ肠ArtifyɓꍞނƂ͐

Revision 2.6  2011/05/18 13:05:31  Average
_TvO̓

Revision 2.5  2011/05/17 16:43:00  Average
IntersectionRecord  R[h

Revision 2.4  2011/05/17 16:20:32  Average
MaterialR[h債Ƃ͖

Revision 2.3  2011/05/17 16:11:31  Average
xN^ZSRecordZ

Revision 2.2  2011/05/17 15:02:11  Average
Unit̎gpςĂ݂܂

@


1.1
log
@Initial revision
@
text
@d399 1
d805 4
a808 1
$Log: RPCALC.PAS $
@
